<?php
/**
 * Created by
 * User: IU Communications
 * Date: 6/21/16
 */


$app->group("/offcal",function()use($app){

    /** @var Load xml data $xmlStr */
    $xmlStr = file_get_contents(config('official-calendar-data'), true);
    $xml = simplexml_load_string($xmlStr);

// echo config('official-calendar-data').'<br/>';
//     echo $xmlStr;
//     exit;

    /** parse input */
    $selected_term = filter_input(INPUT_GET, 'term', FILTER_SANITIZE_STRING);
    $selected_session = filter_input(INPUT_GET, 'session', FILTER_SANITIZE_STRING);
    $select_important_dates = filter_input(INPUT_GET, 'impDates', FILTER_SANITIZE_STRING);
    $selected_event = filter_input(INPUT_GET, 'event', FILTER_SANITIZE_STRING);

	if(!$selected_term) $selected_term = null;
	if(!$selected_session) $selected_session = null;
	if(!$select_important_dates) $select_important_dates = null;
	if(!$selected_event) $selected_event = null;

    $default_term = config('default-term');

    if (!isset($selected_term))
        $selected_term = $default_term;

    /** read terms */
    $term_query = '//term';
    $elements = $xml->xpath($term_query);

    //$terms = "";
    

    /** Build Terms and sessions array from xml */
    array_walk($elements, function ($term) use (&$terms) {
       // $sessions = "";
        foreach ($term->sessions as $session) {
            $sessions[xmltostr($session->description)] = xmltostr($session->description);
        }

        $terms[] = ['code' => xmltostr($term->{"term-code"}),
            'name' => xmltostr($term->{"term-name"}),
            'sessions' => $sessions];
    });
    $terms_select_array = array_combine(array_column($terms, 'code'), array_column($terms, 'name'));



    /** @var Get session for selected term or sessions */
    $default_term_sessions = current(array_filter($terms, function ($term) use ($selected_term) {
        if ($term['code'] == $selected_term)
            return true;
    }));

    $sessions_select_array = $default_term_sessions['sessions'];


    $app->get('/',  function () use ($app,$terms_select_array,$default_term_sessions,$xml,$selected_event,
        $selected_term,$selected_session,$select_important_dates,$sessions_select_array,$terms) {


        /**  Initialize variables */
        $builder = $app->IUCommFormBuilder;

        /** All distinct events for select dropdown */
        $event_elements = $xml->xpath("//term/sessions//event/type/text()");
        $eventTypes = [];// updated for front-end display
        array_walk($event_elements, function ($event) use (&$eventTypes) {
            $str = xmltostr($event);
            if (!in_array($str, $eventTypes)) {
                if(strpos($str,'Automatic')!==false ||
                    strpos($str,'Withdrawal with W or F Begins')!==false ){
                    $eventTypes[$str] = $str;

                }else{
                    $eventTypes[$str] = ucfirst(strtolower($str));
                }
            }
        });

        //[ancestor::sessions/description='Full Term' and ancestor::term/term-code=4168]
        $results_xpath = "//term/sessions";
        //$conditions = "";
        if (isset($selected_term))
            $conditions[] = "parent::term/term-code=" . $selected_term;

        if (isset($selected_session) && $selected_session!="0")//all sessions
            $conditions[] = "description='" . $selected_session . "'";

        $results_xpath .= "[" . join(" and ", $conditions) . "]";

        $xmlresults = $xml->xpath($results_xpath); // for each session bring all events.

        $results = array_map(function($result)use($select_important_dates,$selected_event,$eventTypes){

            $has_selected_event_type = true;
            $has_important_date = true;

          //  $events="";
            foreach($result->event as $e){

                if((isset($selected_event)&& $selected_event!="0")){
                    if(stripos(xmltostr($e->type),$selected_event)!==false)
                        $has_selected_event_type=true;
                     else
                        $has_selected_event_type=false;
                }

               if(isset($select_important_dates)){
                    if($select_important_dates=='1'){
                        if(xmltostr($e->{"important-date"})=="Yes")
                            $has_important_date=true;
                        else
                            $has_important_date=false;
                    }
                    else
                        $has_important_date=true;
                }

                // Include event if it matches the condition.
                if($has_important_date && $has_selected_event_type){
                    $description = $e->description!=""?"<strong>&mdash;</strong>".$e->description->asXML():"";
                    $type = isset($eventTypes[xmltostr($e->type)])
                        ?$eventTypes[xmltostr($e->type)]:xmltostr($e->type);

                    //change types here that need to display differently than they were set in the WCMS -mbc.
                    if($type=='Late registration fee') $type = 'Late registration fee assessed';
                    if($type=='Last day for deans to approve course drop') $type = 'Last day for deans to approve a course drop';

                    $type = '<strong>'.$type.'</strong>';

                    $events[]=["type"=>xmltostr($e->type),
                        "description"=>$type.$description,
                        "date"=>
                            formatDateCalendarDisplay(xmltostr($e->{"start-date"}),xmltostr($e->{"end-date"})),
                        "date_text"=>xmltostr($e->{"date-text"})];
                    $has_selected_event_type = true;
                    $has_important_date = true;

                }

            }

            return ["description"=>$result->description->asXML(),
                "session_start_date"=>
                xmltostr($result->{"session-start-date"}),
                "session_end_date"=>xmltostr($result->{"session-end-date"}),
                "events"=>$events!=""?$events:[]];
        },$xmlresults);

        $html = '';
        /** @var Build Html */
        $html .= $builder->open()
            ->attribute('action', $_ENV['HOME_PATH'] . '/calendar/official-calendar/index.html')
            ->attribute('method', 'GET')
            ->attribute('data-api', $_ENV['HOME_PATH'] . '/_php/api/offcal');
        $html .= '<div class="form-content">';
    
        $html .= $builder->formWrapperOpen()->addClass('thirds');

        $html .=$builder->select('Term', 'term',
            $terms_select_array, array('id' => 'term', 'class' => 'term',
                'data-ajax' => 'true', 'data-controls' =>
                    'select.session', 'data-results-endpoint' =>
                    '/_php/api/offcal/sessions'),
            $selected_term);

        $html .= $builder->select('Session', 'session', array_merge(["0" => "All sessions"], $sessions_select_array),
            array('class' => 'session'),
            isset($selected_session) ? $selected_session : "0");

        //  checkbox($label, $name,$value,$attributes=array())
        $html .= $builder->select('Events', 'event', array_merge(["0" => "All events"], $eventTypes),
            array('class' => 'event'),
            isset($selected_event) ? $selected_event : "0");

        $html .= "<div class=\"form-item grid-item\"><div class=\"form-item-label\"></div> <div class=\"form-item-input\">";

        $impDatesChecked = (isset($_GET['impDates']) && $_GET['impDates'] =='1') ? ' checked = "checked"': '';
        $html .= "<input id=\"impDates\" name='impDates' type=\"checkbox\" value=\"1\"$impDatesChecked> <label for=\"impDates\">Important dates</label></div></div>";

        $html .= $builder->formWrapperClose();
        $html .= '</div>';
        $html .= $builder->button('Go')->attribute('type', 'submit');
        $html .= $builder->close();

        /** selection wrapper */

        $sum= array_reduce(array_map(function($var) {
            return $var['events']!=""?$var['events']:[];
        }, $results),function($carry,$item){
            $carry+=count($item);
            return $carry;
        });

        $selectionWrapper = $builder->selectionWrapper($sum);

        if((isset($selected_term) && $selected_term!="0")){
            if(count($_GET)>0){
                $selectionWrapper->filterItem("term",
                    current(array_column((array_filter($terms,(function($term)use($selected_term){
                        return $term['code']==$selected_term;
                    }))),"name")), $selected_term);
            }
        }
        if((isset($selected_session) && $selected_session!="0")){
            $selectionWrapper->filterItem("session",
                $selected_session, $selected_session);
        }

        if((isset($selected_event) && $selected_event!="0")){
            $selectionWrapper->filterItem("event",$eventTypes[$selected_event], $selected_event);
        }

        #Disabled filter selections to prevent double display on back button - jay 2019/10/04
        //$html .= $selectionWrapper;

        /** results wrapper */

        /** build results */
        $render_table = function($results){
			$summary = ' summary="Table lists session, event and date."';

            $table="";
            $table="<table ". renderTablesawAttributes(). $summary . ">";
            $table.="<thead><tr><th class='w-20'>Session</th><th class='w-60'>Event</th><th class='w-20'>Date</th></tr></thead>";
            $table.="<tbody>";
            foreach($results as $result){
                foreach($result['events'] as $event){
                    $eventDescription = $event['description'];

                    //convert .xml links to .html in event description
                    $dom = new DOMDocument;
                    libxml_use_internal_errors(true);
                    $dom->loadHTML($eventDescription);
                    libxml_use_internal_errors(false);
                    foreach ($dom->getElementsByTagName('a') as $node)
                    {
                      $link = $node->getAttribute("href");
                      if(substr($link, 0, 4)=='http') continue;

                      $newLink = str_replace('.xml', '.html', $link);
                      if(strpos($newLink, '../')!==false) $newLink = $_ENV['HOME_PATH'].'/'.ltrim($newLink, '\.\./');
                      $eventDescription = str_replace($link, $newLink, $eventDescription);
                    }

                    $date = ($event['date']!='') ? $event['date'] : $event['date_text'];
            
                    if($event['date']=="" && $event['date_text']=="")continue;
                    $table.="<tr>";
                    $table.="<td>".$result['description']."</td>";
                    $table.="<td>".$eventDescription."</td>";
                    $table.="<td>".$date."</td>";
                    $table.="</tr>";
                }
            }
            $table.="</tbody></table>";
            return $table;
        };

        if($sum==0)
            $html.=$builder->resultsWrapper("");
        else
            $html.=$builder->resultsWrapper($render_table($results));
        echo $html;
    });
    $app->get('/sessions',  function () use ($app,$selected_term,$sessions_select_array) {

       // $select="";
        $select[]=["id"=>"",'name'=>"All sessions"];
        array_walk($sessions_select_array,function($value,$key)use(&$select){
            $select[]=['id'=>$value,'name'=>$key];
        });
        $app->response->headers->set('Content-Type', 'application/json');

        echo json_encode($select);



    })->name("Sessions");

});